-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["PALADIN"] = {}
lib.classes["PALADIN"][2] = function ()
	cfg.holy=0
	lib.HolyPowerUpdate()
	
	cfg.spells={}
	lib.AddSpell(Heddframe,cfg.spells,"ShoR",{53600}) -- Shield of the Righteous
	lib.AddSpell(Heddframe,cfg.spells,"CS",{35395}) -- Crusader Strike
	lib.AddSpell(Heddframe,cfg.spells,"J",{20271}) -- Judgement
	lib.AddSpell(Heddframe,cfg.spells,"HoW",{24275}) -- Hammer of Wrath
	lib.AddSpell(Heddframe,cfg.spells,"AS",{31935}) -- Avenger's Shield
	lib.AddSpell(Heddframe,cfg.spells,"Con",{26573}) -- Consecration
	lib.AddSpell(Heddframe,cfg.spells,"HW",{2812}) -- Holy Wrath
	lib.AddSpell(Heddframe,cfg.spells,"SoT",{31801}) -- Seal of Truth
	lib.AddSpell(Heddframe,cfg.spells,"HotR",{53595}) -- Hammer of the Righteous
					
	cfg.auras={}
	lib.AddAura(cfg.auras,"SoI",20165,"buff","player") -- Seal of Insigh
	lib.AddAura(cfg.auras,"SoR",20154,"buff","player") -- Seal of Righteousness
	lib.AddAura(cfg.auras,"SoT",31801,"buff","player") -- Seal of Truth
			
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Seal")
	table.insert(cfg.plistdps,"ShoR")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"J")
	table.insert(cfg.plistdps,"HoW")
	table.insert(cfg.plistdps,"AS")
	table.insert(cfg.plistdps,"Con")
	table.insert(cfg.plistdps,"HW")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Seal")
	table.insert(cfg.plistaoe,"HotR")
	table.insert(cfg.plistaoe,"Con")
	table.insert(cfg.plistaoe,"HW")
	table.insert(cfg.plistaoe,"AS")
	table.insert(cfg.plistaoe,"ShoR")
	table.insert(cfg.plistaoe,"J")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["Seal"] = function ()
			local t = lib.GetAura({"SoI","SoR","SoT"})
			if t<3 then
				return lib.SimpleCDCheck("SoT")
			end
			return nil
		end,
		["ShoR"] = function()
			if cfg.holy==3 then
				return lib.SimpleCDCheck("ShoR")
			end
			return nil
		end,
--[[		["HotR"] = function()
			return lib.SimpleCDCheck("HotR")
		end,
		["CS"] = function()
			return lib.SimpleCDCheck("CS")
		end,
		["J"] = function()
			return lib.SimpleCDCheck("J")
		end,
		["HoW"] = function()
			return lib.SimpleCDCheck("HoW")
		end,
		["AS"] = function()
			return lib.SimpleCDCheck("AS")
		end,
		["Con"] = function()
			return lib.SimpleCDCheck("Con")
		end,
		["HW"] = function()
			return lib.SimpleCDCheck("HW")
		end,]]
		["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
		end,
	}

	cfg.numcase=0
	for key, value in pairs(cfg.plist) do
		if cfg.case[value] then
			cfg.numcase=cfg.numcase+1
		end
	end
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			lib.SetPriority()
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			lib.SetPriority()
		end
		print(cfg.mode)
	end
	
--	cfg.onpower=true
	cfg.onhealth=true
	cfg.onupdate=true
	return true
end

lib.classes["PALADIN"][3] = function ()
	cfg.holy=0
	lib.HolyPowerUpdate()
	
	cfg.spells={}
--	lib.AddSpell(Heddframe,cfg.spells,"ShoR",{53600}) -- Shield of the Righteous
	lib.AddSpell(Heddframe,cfg.spells,"Inq",{84963}) -- Inquisition
	lib.AddSpell(Heddframe,cfg.spells,"CS",{35395}) -- Crusader Strike
	lib.AddSpell(Heddframe,cfg.spells,"J",{20271}) -- Judgement
	lib.AddSpell(Heddframe,cfg.spells,"HoW",{24275}) -- Hammer of Wrath
	lib.AddSpell(Heddframe,cfg.spells,"AS",{31935}) -- Avenger's Shield
	lib.AddSpell(Heddframe,cfg.spells,"Con",{26573}) -- Consecration
	lib.AddSpell(Heddframe,cfg.spells,"HW",{2812}) -- Holy Wrath
	lib.AddSpell(Heddframe,cfg.spells,"SoT",{31801}) -- Seal of Truth
	lib.AddSpell(Heddframe,cfg.spells,"HotR",{53595}) -- Hammer of the Righteous
	lib.AddSpell(Heddframe,cfg.spells,"Exo",{879}) -- Exorcism
	lib.AddSpell(Heddframe,cfg.spells,"TV",{85256}) -- Templar's Verdict
	lib.AddSpell(Heddframe,cfg.spells,"DS",{53385}) -- Divine Storm
	
	cfg.auras={}
	lib.AddAura(cfg.auras,"SoI",20165,"buff","player") -- Seal of Insigh
	lib.AddAura(cfg.auras,"SoR",20154,"buff","player") -- Seal of Righteousness
	lib.AddAura(cfg.auras,"SoT",31801,"buff","player") -- Seal of Truth
	lib.AddAura(cfg.auras,"AoW",59578,"buff","player") -- The Art of War
	lib.AddAura(cfg.auras,"DivPurp",90174,"buff","player") -- Divine Purpose
	lib.AddAura(cfg.auras,"Inq",84963,"buff","player") -- Inquisition
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Seal")
	table.insert(cfg.plistdps,"Inq")
	table.insert(cfg.plistdps,"CS")
	table.insert(cfg.plistdps,"HoW")
	table.insert(cfg.plistdps,"Exo")
	table.insert(cfg.plistdps,"TV")
	table.insert(cfg.plistdps,"J")
	table.insert(cfg.plistdps,"HW")
	table.insert(cfg.plistdps,"Con")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Seal")
	table.insert(cfg.plistaoe,"Inq")
	table.insert(cfg.plistaoe,"DS")
	table.insert(cfg.plistaoe,"HoW")
	table.insert(cfg.plistaoe,"Exo")
	table.insert(cfg.plistaoe,"TV")
	table.insert(cfg.plistaoe,"J")
	table.insert(cfg.plistaoe,"Con")
	table.insert(cfg.plistaoe,"HW")
	table.insert(cfg.plistaoe,"end")

	cfg.plist = cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["Seal"] = function ()
			local t = lib.GetAura({"SoI","SoR","SoT"})
			if t<3 then
				return lib.SimpleCDCheck("SoT")
			end
			return nil
		end,
		["TV"] = function()
			if cfg.holy==3 or lib.GetAura({"DivPurp"})>0 then
				return lib.SimpleCDCheck("TV")
			end
			return nil
		end,
		["CS"] = function()
			if cfg.holy<3 then
				return lib.SimpleCDCheck("CS")
			end
			return nil
		end,
		["DS"] = function()
			if cfg.holy<3 then
				return lib.SimpleCDCheck("DS")
			end
			return nil
		end,
		["Inq"] = function()
			local t = lib.GetAura({"Inq"})
			if t<3 then
				return lib.SimpleCDCheck("Inq")
			end
			return nil
		end,
		["Exo"] = function()
			local t = lib.GetAura({"AoW"})
			if t>0 then
				return lib.SimpleCDCheck("Exo")
			end
			return nil
		end,
--[[		["HotR"] = function()
			return lib.SimpleCDCheck("HotR")
		end,
		["CS"] = function()
			return lib.SimpleCDCheck("CS")
		end,
		["J"] = function()
			return lib.SimpleCDCheck("J")
		end,
		["HoW"] = function()
			return lib.SimpleCDCheck("HoW")
		end,
		["AS"] = function()
			return lib.SimpleCDCheck("AS")
		end,
		["Con"] = function()
			return lib.SimpleCDCheck("Con")
		end,
		["HW"] = function()
			return lib.SimpleCDCheck("HW")
		end,]]
		["end"] = function ()
			if cfg.cmintime~=cfg.maxmintime then return nil end
			lib.UpdateBar(nil)
		end,
	}

	cfg.numcase=0
	for key, value in pairs(cfg.plist) do
		if cfg.case[value] then
			cfg.numcase=cfg.numcase+1
		end
	end
	
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			lib.SetPriority()
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			lib.SetPriority()
		end
		print(cfg.mode)
	end
	
--	cfg.onpower=true
	cfg.onhealth=true
	cfg.onupdate=true
	return true
end

lib.classevents["PALADIN"] = function()

function Heddevents:UNIT_POWER(unit,...)
	if unit=="player" then
		if lib.HolyPowerUpdate() then
			lib.SetPriority()
		end
	end
end

	lib.rangecheck=function()
		if lib.inrange("CS") then
			lib.bdcolor(Heddframe.bd,nil)
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	
	lib.myonupdate = function()
		lib.rangecheck()
	end	
--[[	function Heddevents:UNIT_SPELLCAST_SUCCEEDED(unit,spell)
		if unit=="player" and spell==cfg.spells["pest"].name then
			cfg.now = GetTime()
			cfg.lastpest=cfg.now
			lib.SetPriority()
		end
	end]]
	
--[[	lib.mytal = function()
		local nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(3,3)
		cfg.destime = (21+4*currRank)
		nameTalent, icon, tier, column, currRank, maxRank= GetTalentInfo(2,1)
		cfg.rpmax = (100+10*currRank)
	end]]
end